/*
 * Copyright (C) 2010 Apple Inc. All rights reserved.
 * Copyright (C) 2012 Sony Computer Entertainment Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE INC. AND ITS CONTRIBUTORS ``AS IS''
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL APPLE INC. OR ITS CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

#include "config.h"
#include "WebInspectorProxy.h"

#if ENABLE(INSPECTOR)


using namespace WebCore;

namespace WebKit {

WebPageProxy* WebInspectorProxy::platformCreateInspectorPage()
{
    return 0;
}

void WebInspectorProxy::platformOpen()
{
}

void WebInspectorProxy::platformDidClose()
{
}

void WebInspectorProxy::platformBringToFront()
{
}

bool WebInspectorProxy::platformIsFront()
{
    return false;
}

void WebInspectorProxy::platformInspectedURLChanged(const String& urlString)
{
}

unsigned WebInspectorProxy::platformInspectedWindowHeight()
{
    return 0;
}

void WebInspectorProxy::platformAttach()
{
}

void WebInspectorProxy::platformDetach()
{
}

void WebInspectorProxy::platformSetAttachedWindowHeight(unsigned height)
{
}

String WebInspectorProxy::inspectorPageURL() const
{
    return inspectorBaseURL() + String("/inspector.html");
}

String WebInspectorProxy::inspectorBaseURL() const
{
    return String("file://") + getenv("MANX_INSPECTOR_SERVER_PATH");
}

} // namespace WebKit

#endif // ENABLE(INSPECTOR)
